exports.merge = async function(obj1, obj2)
{
	if(obj2 == undefined)
	{
		return obj1
	}


	if(obj1 == undefined)
	{
		return obj2
	}
	if(obj2!=undefined && Object.keys(obj2).length != 0 && typeof obj2 == "object")
	{
   		for(var i_obj2 in obj2)
		{
			
			if(typeof obj1[i_obj2] != "object")
			{
				if(obj2[i_obj2] == undefined)
				{
					delete(obj1[i_obj2])
				}
				else
				{
					obj1[i_obj2] = obj2[i_obj2]
				}
				

			}
			else
			{
				obj1[i_obj2] = await this.merge(obj1[i_obj2],obj2[i_obj2])
			}
		}
	}

	return obj1;
}


//Поиск значения в объекте 
exports.search_value = async function(obj, value, result = undefined)
{
		
		for(var i in obj)
		{
			if(obj[i]!=undefined && Object.keys(obj[i]).length != 0 && typeof obj[i] == "object")
			{
				var r  = await this.search_value(obj[i], value)
				if(r !=undefined)
				{
					var arr = {}
					arr[i] = r
					result = await this.merge(result, arr)
				}
			}
			else
			{
				if(obj[i] == value)
				{
					var arr = {}
					arr[i] = obj[i]
					result = await this.merge(result, arr)
				}
			}
		}

		
	return result
	
	
}


//Удалить все пустые ключи
exports.clear_empty = async function(obj)
{
	
	if(obj!=undefined && Object.keys(obj).length!=0)
	{
		for(var i in obj)
		{
			if(typeof(obj[i]) == 'object')
			{
				var r  = await this.merge(obj[i],await this.clear_empty(obj[i]))
				if(Object.keys(r).length!=0)
				{
					obj[i] = r
				}
				else
				{
					delete(obj[i])
				}
			}
			else
			{
				if(obj[i] == "")
				{
					delete(obj[i])
				}
			}
		}
	}
	else
	{
		return undefined
	}
	

	return obj
}


exports.sort_arr = async function(arr,key,type_sort, test=false)
{
	return new Promise(resolve => {

		arr = Object.values(arr)
		if(isNaN(arr[Object.keys(arr)[0]][key]) == false) //Если значение цифра
		{
			arr = arr.sort(function(a,b) {
				if(a[key]==undefined)
				{
					return arr
				}

				if(type_sort == ">")
				{
			    	return a[key] - b[key];
				}

				if(type_sort == "<")
				{
			    	return b[key] - a[key];
				}
			});
		}
		else //Если значение строка
		{
			arr = arr.sort(function(a,b) {
				if(a[key]==undefined)
				{
					return arr
				}

				if(typeof a[key] == 'string')
				{
					var x = a[key].toLowerCase();
				}
				else
				{
					var x = a[key];
				}

				if(typeof b[key] == 'string')
				{
					var y = b[key].toLowerCase();
				}
				else
				{
					var y = b[key];
				}
				

				if(type_sort == "<")
				{
			    	return x < y ? -1 : x > y ? 1 : 0;
			    }
			    if(type_sort == ">")
				{
			    	return x > y ? -1 : x < y ? 1 : 0;
			    }


			});
		}
	  resolve(arr)  
    });


}


/*поиск значений в объекте по стоковому ключу строковому например value[button_next]*/
exports.get_val_str_key = async function(alias, value_field)
{
	var new_alias = await this.obj_key_alias_to_array(alias, "")
	var res = await get_key_val(Object.keys(new_alias)[0],new_alias , value_field)


	async function get_key_val(key, alias, value_field)
	{
		var result = value_field[key]
		if(typeof alias[key] == 'object' && value_field[key]!=undefined)
		{
			result = get_key_val(Object.keys(alias[key])[0],alias[key] , value_field[key])
		}

		return result
		
	}

	return res

}

exports.obj_key_to_array = async function(array)
{

	async function get_child_key(obj,value, result = {})
	{	
		if(obj[Object.keys(obj)[0]]!=undefined)
		{
			result[Object.keys(obj)[0]] = await get_child_key(obj[Object.keys(obj)[0]],value)
		}
		else
		{
			result = value
		}
		return result
	}
	


	async function parse_key_to_array(alias,value)
	{
		var json_alias = alias
		json_alias = json_alias.split(']').join('');
		json_alias = json_alias.split('[').join('":{"');		
		json_alias = '{"'+json_alias+'":""'+"}".repeat(alias.split("[").length - 1)+"}"		
		json_alias = JSON.parse(json_alias)
		var result = {}
		result[Object.keys(json_alias)[0]] = await get_child_key(json_alias[Object.keys(json_alias)[0]],value)
		return result
	}

	var result = {}
	for(alias in array)
	{

		if(alias.indexOf('[')!=-1)
		{

			result = await this.merge(result,await parse_key_to_array(alias,array[alias]))
		}
		else
		{
			result[alias] =  array[alias]

		}
	}
	return result
}




//Вернет разницу между массивами

exports.array_diff = async function(arr1, arr2)
{

    var a = [], diff = [];

    for (var i = 0; i < arr1.length; i++) {
        a[arr1[i]] = true;
    }

    for (var i = 0; i < arr2.length; i++) {
        if (a[arr2[i]]) {
            delete a[arr2[i]];
        } else {
            a[arr2[i]] = true;
        }
    }

    for (var k in a) {
        diff.push(k);
    }

    return diff;
}